<?php
require 'config.php';

if (isset($_GET['state']) && $_GET['state'] !== $_SESSION['oauth2state']) {
    unset($_SESSION['oauth2state']);
    exit('Invalid state.');
}

if (!isset($_GET['code'])) {
    exit('No authorization code provided.');
}

try {
    // Exchange authorization code for an access token
    $accessToken = $provider->getAccessToken('authorization_code', [
        'code' => $_GET['code']
    ]);

    // Fetch the resource owner details
    $resourceOwner = $provider->getResourceOwner($accessToken);
    $userDetails = $resourceOwner->toArray();

    // Store access token and user details in the session
    $_SESSION['access_token'] = $accessToken->getToken();
    $_SESSION['user_details'] = $userDetails;

    // Redirect to secure page
    header('Location: secure.php');
    exit;
} catch (\League\OAuth2\Client\Provider\Exception\IdentityProviderException $e) {
    exit('Error: ' . $e->getMessage());
}
